
%ifndef invoke
%include "asm.mac"
%endif

%ifndef classname
%error "define classname before including class.inc"
%endif

%define this ebp
%define arg(x) [esp+%$argbase+(4*x)]
%define arg(x,y) [esp+%$argbase+(4*x)+(4*y)] 
%define argex(x,y) [esp+%$argbase+(4*x)+y]
%define member(mmm)      [this+s %+ classname %+ . %+ mmm]
%define member(mmm,stack) [this+s %+ classname %+ . %+ mmm + (stack<<2)]
%define uses ,
%define alloca_size 0

; METHOD mymethod, number_of_arguments {uses esi{,edi{,ebx}}}

%imacro method 2-5
	align 4

	%push   method
	%assign %$argbase 8
	%assign %$nPreservedRegs 0

	%assign %$nArgs (%2 * 4) + 4 

	global  classname %+ @%1
classname %+ @%1:

	%ifndef METHOD_NO_THIS
	push   this
	mov    this, [esp+8]
	%assign %$argbase %$argbase+4
	%endif

	%if %0 >= 3
		%assign %$nPreservedRegs 1
		%assign %$argbase %$argbase+4
		%define %$preserved_register_1 %3 
		push    %3
	%endif
	%if %0 >= 4
		%assign %$nPreservedRegs 2
		%assign %$argbase %$argbase+4
		%define %$preserved_register_2 %4 
		push    %4
	%endif
	%if %0 = 5
		%assign %$nPreservedRegs 3
		%assign %$argbase %$argbase+4
		%define %$preserved_register_3 %5 
		push    %5
	%endif
%endm






%imacro endmethod 0
	%if alloca_size > 0
		add esp,alloca_size
		%assign %$argbase %$argbase+alloca_size
		%define alloca_size 0
	%endif

	%if %$nPreservedRegs = 3
		pop %$preserved_register_3
		%assign %$nPreservedRegs 2
	%endif
	%if %$nPreservedRegs = 2
		pop %$preserved_register_2
		%assign %$nPreservedRegs 1
	%endif
	%if %$nPreservedRegs = 1
		pop %$preserved_register_1
		%assign %$nPreservedRegs 0
	%endif

	%ifndef METHOD_NO_THIS
	pop     this
	%else
	%undef METHOD_NO_THIS
	%endif
	ret     %$nArgs
	%pop
%endm



%macro alloca 1
	%define alloca_size %1
	sub esp,%1
	%assign %$argbase %$argbase+%1
%endm


